%define anolis_release		1

%{bcond_without perl_Net_HTTP_enables_ipv6}
%{bcond_with perl_Net_HTTP_enables_network_test}
%{bcond_without perl_Net_HTTP_enables_ssl}

Name:           perl-Net-HTTP
Version:	6.23
Release:        %{anolis_release}%{?dist}
Summary:        Low-level HTTP connection (client)
License:        GPL-1.0-or-later OR Artistic-1.0-Perl
URL:            https://metacpan.org/release/Net-HTTP
Source0:        https://cpan.metacpan.org/authors/id/O/OA/OALDERS/Net-HTTP-%{version}.tar.gz
BuildArch:      noarch

BuildRequires: coreutils, make
BuildRequires: perl-generators, perl-interpreter
BuildRequires: perl-interpreter
BuildRequires: perl(:VERSION) >= 5.6.2, perl(Config)
BuildRequires: perl(ExtUtils::MakeMaker) >= 6.76, perl(Getopt::Long)
BuildRequires: perl(strict), perl(base)
BuildRequires: perl(Carp), perl(Compress::Raw::Zlib)

%if %{with perl_Net_HTTP_enables_ipv6}
BuildRequires:  perl(IO::Socket::IP)
%else
BuildRequires:  perl(IO::Socket)
%endif
%if %{with perl_Net_HTTP_enables_ssl}

BuildRequires:  perl(IO::Socket::SSL) >= 2.012
%endif
BuildRequires: perl(IO::Uncompress::Gunzip) perl(Symbol)
BuildRequires: perl(URI) perl(warnings)
BuildRequires: perl(Data::Dumper) perl(File::Spec)
BuildRequires: perl(IO::Select) perl(IO::Socket::INET)
BuildRequires: perl(Socket) perl(Test::More)

Requires:       perl(Compress::Raw::Zlib) perl(IO::Uncompress::Gunzip)

%if %{with perl_Net_HTTP_enables_ipv6}
Requires:       perl(IO::Socket::IP)
%else
Requires:       perl(IO::Socket)
%endif
Requires:       perl(Symbol)
%if %{with perl_Net_HTTP_enables_ssl}
Requires:       perl(IO::Socket::SSL) >= 2.012
%endif
Conflicts:      perl-libwww-perl < 6

%description
perl-Net-HTTP is a Perl module that provides an easy-to-use interface for
sending HTTP requests and receiving HTTP responses. With this module, you
can create HTTP clients that can interact with web servers to retrieve and
send data, including HTML pages, XML documents, and JSON data.

The module handles all the details of the HTTP protocol, including managing
connections, sending requests, receiving responses, and handling errors. It
supports both HTTP/1.0 and HTTP/1.1, and can handle both plain-text and
SSL-encrypted connections.

In addition to the basic GET and POST methods, perl-Net-HTTP also supports
a variety of HTTP headers, cookies, and authentication methods. This makes
it an ideal module for building robust and efficient web clients in Perl.

The Net::HTTP class is a low-level HTTP client. An instance of the
Net::HTTP class represents a connection to an HTTP server. The HTTP
protocol is described in RFC 2616. The Net::HTTP class supports HTTP/1.0
and HTTP/1.1.

%package tests
Summary:        Tests for %{name}
Requires:       %{name} = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:       perl-Test-Harness
%if %{with perl_Net_HTTP_enables_network_test}
%if %{with perl_Net_HTTP_enables_ssl}
Requires:  perl(IO::Socket::SSL) >= 2.012
%endif
%endif

%description tests
Tests from %{name}. Execute them
with "%{_libexecdir}/%{name}/test".

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n Net-HTTP-%{version}
%if %{without perl_Net_HTTP_enables_network_test}
rm t/live*.t
perl -i -ne 'print $_ unless m{^t/live.*\.t}' MANIFEST
%endif

for F in t/*.t; do
    perl -i -MConfig -pe 'print qq{$Config{startperl}\n} if $. == 1 && !s{\A#!.*\bperl}{$Config{startperl}}' "$F"
    chmod +x "$F"
done

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1
%{make_build}

%install
%{make_install}
%{_fixperms} %{buildroot}/*

mkdir -p %{buildroot}%{_libexecdir}/%{name}
cp -a t %{buildroot}%{_libexecdir}/%{name}
cat > %{buildroot}%{_libexecdir}/%{name}/test << 'EOF'
#!/bin/sh
set -e
cd %{_libexecdir}/%{name} && exec prove -I . -j "$(getconf _NPROCESSORS_ONLN)"
EOF
chmod +x %{buildroot}%{_libexecdir}/%{name}/test

%check
export HARNESS_OPTIONS=j$(perl -e 'if ($ARGV[0] =~ /.*-j([0-9][0-9]*).*/) {print $1} else {print 1}' -- '%{?_smp_mflags}')
make test

%files
%license LICENSE
%{perl_vendorlib}/*
%{_mandir}/man3/*

%files tests
%{_libexecdir}/%{name}

%files doc
%doc Changes CONTRIBUTORS README.md


%changelog
* Mon Jul 07 2025 wenyuzifang <lzx02244079@alibaba-inc.com> - 6.23-1
- Updated to version 6.23 to fix xxxxxxxxx


* Tue Apr 11 2023 Ziyang Zhang <ZiyangZhang@linux.alibaba.com> -6.22-2
- Optimize spec file

* Thu Feb 02 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 6.22-1
- init from upstream
